#!/bin/bash -l#
# ./extract_level.sh $EXPID $VAR 
#
#
# This script will extract the 7 levels from the 3D atmospheric monthly files generated by atmosphere diagnostic.
#
# Written by Chloe Prodhomme
#
# Barcelona Super Computing Center
# Created:  May 05, 2016

#module load NCO
#module load CDO
#!/bin/bash
set -vx

freq=_6hourly
exp=${1} #the expid
var=${2} # the 3D variable name
nblev=7 #To be changed if the file have more than 7 levels

dir=/esnas/exp/ecearth/$exp/monthly_mean/
dirori=$dir/${varori}$freq
cd $dirori
for f in $(ls ${var}*01.nc)
do
    aux=$(ncdump -v level $dirori/$f | tail -2)
    levaux=${aux/"level = "/""}
    levaux=${levaux/"}"/""}
    levaux=${levaux/";"/""}
    IFS=', ' levlst=($levaux)
    for ilev in $(seq 0 $((nblev-1))) 
    do
	level=${levlst[$ilev]}
	varnew=${varori}${level}
	dirout=$dir/${varnew}$freq
	mkdir -p $dirout
	fileout=${f/$varori/$varnew}
	ncks -O -d level,$ilev $dirori/$f -o $dirout/$fileout
	ncrename -v $varori,$varnew $dirout/$fileout
	ncks -O -x -v level $dirout/$fileout -o $dirout/${fileout}_tmp
	ncwa -O -a level $dirout/${fileout}_tmp $dirout/$fileout
	rm -f $dirout/${fileout}_tmp
    done
done
